function getColumns() {
	let columns = [
		{
			title: `N°`,
			data: `id`,
			className: 'text-center'
		},
		{
			title: `APELLIDOS Y NOMBRES`,
			data: null,
			className: `text-center`,
			render: (data) => {
				let nombresCompletos;
				let nombres = data.trabajador_nombres;
				let apellidos = data.trabajador_apellidos;
				nombresCompletos = `${apellidos} ${nombres}`;

				return nombresCompletos;
			}
		},
		{
			title: "SEDE",
			data: "sede_descripcion",
			className: "text-center"
		},
		{
			title: `FECHA`,
			data: `fecha_asistencia`,
			className: 'text-center'
		},
		{
			title: `HORARIO`,
			data: `horario`,
			className: 'text-center'
		},
		{
			title: `MARC. ENTRADA`,
			data: null,
			className: 'text-center',
			render: (data) => {
				let label = "";

				if (data.estadoasistencia_codigo == 3 || data.estadoasistencia_codigo == 4 || data.estadoasistencia_codigo == 6 || data.estadoasistencia_codigo == 7 || data.estadoasistencia_codigo == 8 || data.estadoasistencia_codigo == 9) {
					return `-`;
				}

				if (data.huella_entrada === 1) {
					label = "text-migration font-weight-bold";
				} else if (data.huella_entrada === 0) {
					label = "text-default";
				}

				if (!data.marcacion_entrada) {
					return null;
				}

				return `<span class="${label}">${data.marcacion_entrada}</span>`;
			}
		},
		{
			title: `AULAS`,
			data: `aulas`,
			className: 'text-center'
		},
		{
			title: `FIRMÓ SALIDA <input type="checkbox" id="chkFirmaTodo">`,
			data: `firmo_salida`,
			className: 'text-center',
			render: (data) => {
				let label = "";
				let contenido = "";

				switch (data) {
					case 0:
						label = "label label-danger";
						contenido = "NO";
						break;

					case 1:
						label = "label label-success";
						contenido = "SI";
						break;

					case "":
						label = "label bg-purple";
//						contenido = "PENDIENTE";
						return `<input type="checkbox" class="chkFirma">`;
						break;

				}

				return `<span class="${label}">${contenido}</span>`;
			}
		},
		{
			title: 'ESTADO ASISTENCIA'.split(' ').join('<br>'),
			data: null,
			className: "text-center",
			render: (data) => {
				let label = "";
				let estado = "";

				switch (data.estadoasistencia_codigo) {
					case 1:
						label = "label label-success";
						estado = "TEMPRANO";
						break;
					case 2:
						label = "label label-warning";
						estado = "TARDANZA";
						break;
					case 3:
						label = "label label-danger";
						estado = "FCA";
						break;
					case 4:
						label = "label label-danger";
						estado = "FSA";
						break;
					case 5:
						label = "label label-default";
						estado = "NO MARCÓ";
						break;
					case 6:
						label = "label label-info";
						estado = "VACACIONES";
						break;
					case 7:
						label = "label label-info";
						estado = "FERIADO";
						break;
					case 8:
						label = "label label-info";
						estado = "LCGH";
						break;
					case 9:
						label = "label label-info";
						estado = "LSGH";
						break;
					case 10:
						label = "label bg-purple";
						estado = "ENTRADA PENDIENTE";
						break;
					case 11:
						label = "label bg-purple";
						estado = "SALIDA PENDIENTE";
						break;
					case null:
					case "":
						label = "label bg-purple";
						estado = "PENDIENTE";
						break;
				}

				return `<span class="${label}">${estado}</span>`;
			}
		},
		{
			title: `ACCIONES`,
			data: null,
			className: 'text-center',
			render: (data) => {
				let acciones = "";
				let firmar = "";
				switch (data.estadoasistencia_codigo) {
					case 10:
					case 11:
					case null:
					case "":
						let registrar = `<span data-toggle="tooltip" data-placement="left" title="Editar" style="cursor: pointer"> <i class='registrar icon-plus-circle2 text-success-700'></i>&nbsp;&nbsp; </span>`;
						let editar = `<span data-toggle="tooltip" data-placement="left" title="Editar" style="cursor: pointer"> <i class='editar icon-pencil text-slate-800'></i>&nbsp;&nbsp; </span>`;
						let aprobar = `<span data-toggle="tooltip" data-placement="left" title="Aprobar" style="cursor: pointer"> <i class='aprobar icon-checkmark-circle text-success-700'></i>&nbsp;&nbsp; </span>`;
						let anular = `<span data-toggle="tooltip" data-placement="left" title="Anular" style="cursor: pointer"> <i class='anular icon-cancel-circle2 text-danger-700'></i>&nbsp;&nbsp; </span>`;

						acciones = registrar;
						break;
				}

				firmar = `<span class="" style="cursor:pointer;"><i class="boligrafo text-slate-800"></i></span>`;
				acciones += firmar;
				return acciones;
			}
		}
	];

	return columns;
}


const listarPersonal = (selectorName) => {
	initSelect2(selectorName, baseURLRest + URI_TRABAJADORES, {title: "nombresapellidos", subtitle: "documentoidentidad"});
};

const listarSedes = (selectorName) => {
	ajaxWebService.get(URI_SEDES).then((result) => {
		let sedes = result.data;
		sedes = _.orderBy(sedes, s => s.descripcion);
		let html = `<option value="">[TODOS]</option>`;
		sedes.forEach(sede => html += `<option value="${sede.codigo}">${sede.descripcion}</option>`);
		$(`${selectorName}`).html(html);
		$(selectorName).select2();
	});
};


const listarEstadoAsistencia = (nodeIdentifier) => {
	ajaxWebService.get(URI_ESTADO_ASISTENCIA).then((response) => {
		let estados = response.data;
		let html = "";
		estados
			.filter(e => e.codigo != 10 && e.codigo != 11)
			.forEach(e => html += `<option value="${e.codigo}">${e.descripcion}</option>`);
		$(nodeIdentifier).html(html);
		$(nodeIdentifier).selectpicker('refresh');
		$('.selectpicker').selectpicker({
			style: 'btn-info',
			size: 4
		});
		$(".btn.dropdown-toggle.bs-placeholder").removeClass("btn-info");
		$(".btn.dropdown-toggle.bs-placeholder").css({
			border: "1px solid #ddd",
			backgroundColor: "#fff"
		});
	});
}



const mostrarModalRegistroAsistencia = (data) => {

}

function listarAsistenciaDocentes(objParams = {}){
	ajaxWebService.get(URI_DOCENTES_ASISTENCIAS, objParams).then((response) => {
		let columns = getColumns();

		let wrapsNameDatatable = `divDatatable`;
		let classNameForDatatable = `display table table-bordered`;

		makeDatatable(
			wrapsNameDatatable,
			{
				data: response.data,
				columns,
			},
			classNameForDatatable,
			).then((nodes) => {
			$(".chkFirma, #chkFirmaTodo").uniform();
			nodes.container
				.off()
				.on("click", ".registrar", function () {
					let data = nodes.datatable.DataTable().row($(this).parents("tr")).data();
					mostrarModalRegistroAsistencia(data);
				})
				.on("click", "#chkFirmaTodo", (e) => seleccionarCheckBoxTodo($(e.currentTarget)))
				.on("click", ".chkFirma", (e) => seleccionarCheckBox());

		});
	});
}

const seleccionarCheckBoxTodo = (tr) => {
	if (tr.prop('checked')) {
		$('.chkFirma').prop('checked', true).uniform()
	} else {
		$('.chkFirma').prop('checked', false).uniform()
	}
}

const seleccionarCheckBox = () => {
	debugger
	if ($('.chkFirma:checked').length === $('.chkFirma').length) {
		$('#chkFirmaTodo').prop('checked', true).uniform()
	} else {
		$('#chkFirmaTodo').prop('checked', false).uniform()
	}
}


const aplicarFiltro = () => {

}

$(document).ready(function () {
	initDatePicker("#dpFechaInicioFiltro", "#dpFechaFinFiltro");
	listarSedes("#cboSedesFiltro");
	listarPersonal("#cboPersonalFiltro");
	listarEstadoAsistencia("#cboEstadoAsistenciaFiltro");
	$("#btnAplicarFiltro").click(aplicarFiltro);
	$("#btnMostrarTodo").click(listarAsistenciaDocentes);
});